 /***************************************************************************\
|*                                                                           *|
|*        Copyright (c) 1999 NVIDIA, Corp.  All rights reserved.             *|
|*                                                                           *|
|*     NOTICE TO USER:   The source code  is copyrighted under  U.S. and     *|
|*     international laws.   NVIDIA, Corp. of Sunnyvale, California owns     *|
|*     the copyright  and as design patents  pending  on the design  and     *|
|*     interface  of the NV chips.   Users and possessors of this source     *|
|*     code are hereby granted  a nonexclusive,  royalty-free  copyright     *|
|*     and  design  patent license  to use this code  in individual  and     *|
|*     commercial software.                                                  *|
|*                                                                           *|
|*     Any use of this source code must include,  in the user documenta-     *|
|*     tion and  internal comments to the code,  notices to the end user     *|
|*     as follows:                                                           *|
|*                                                                           *|
|*     Copyright (c) 1993-1997  NVIDIA, Corp.    NVIDIA  design  patents     *|
|*     pending in the U.S. and foreign countries.                            *|
|*                                                                           *|
|*     NVIDIA, CORP.  MAKES  NO REPRESENTATION ABOUT  THE SUITABILITY OF     *|
|*     THIS SOURCE CODE FOR ANY PURPOSE.  IT IS PROVIDED "AS IS" WITHOUT     *|
|*     EXPRESS OR IMPLIED WARRANTY OF ANY KIND.  NVIDIA, CORP. DISCLAIMS     *|
|*     ALL WARRANTIES  WITH REGARD  TO THIS SOURCE CODE,  INCLUDING  ALL     *|
|*     IMPLIED   WARRANTIES  OF  MERCHANTABILITY  AND   FITNESS   FOR  A     *|
|*     PARTICULAR  PURPOSE.   IN NO EVENT SHALL NVIDIA, CORP.  BE LIABLE     *|
|*     FOR ANY SPECIAL, INDIRECT, INCIDENTAL,  OR CONSEQUENTIAL DAMAGES,     *|
|*     OR ANY DAMAGES  WHATSOEVER  RESULTING  FROM LOSS OF USE,  DATA OR     *|
|*     PROFITS,  WHETHER IN AN ACTION  OF CONTRACT,  NEGLIGENCE OR OTHER     *|
|*     TORTIOUS ACTION, ARISING OUT  OF OR IN CONNECTION WITH THE USE OR     *|
|*     PERFORMANCE OF THIS SOURCE CODE.                                      *|
|*                                                                           *|
 \***************************************************************************/


/*
 * Registry variables.
 *
 * These are defined here and used throughout resman.
 * They must be set by when loading the module using insmod.
 *
 * Registry names within linux look like: NVreg_NAME.
 * The 'NAME' portion is the leaf windows registry name with spaces
 * converted to '_'.  So 'Display Type' becomes 'Display_Type'
 *
 * TODO:
 *
 *    persistence
 *        This could be added by saving them outside resman using an ioctl
 *        and then playing them back at startup.
 *
 *    device dependence
 *        currently just one global namespace
 *        This could be easily added as NVreg_01_foofoo to mean symbol foofoo
 *        on the 2nd card in system.
 *
 */

#ifndef __KERNEL__
#  define __KERNEL__
#endif
#ifndef MODULE
#  define MODULE
#endif

#define __NO_VERSION__
#define EXPORT_SYMTAB
#include <linux/module.h>

#define RM_HEADERS_MINIMAL      // we just need top half of nvrm.h, not the entire
#include <nvrm.h>

/*
 * The 2nd argument to MODULE_PARM is used to verify parameters given to the module.
 * It should be a string in the following format:
 *   	[min[-max]]{b,h,i,l,s}
 * The MIN and MAX specifiers delimit the length of the array.  If MAX
 * is omitted, it defaults to MIN; if both are omitted, the default is 1.
 * The final character is a type specifier:
 *      b	byte
 *	h	short
 *	i	int
 *	l	long
 *	s	string
 *
 * Note: much of resman considers the *existence* of a flag to be sufficient.
 *       Ie: value is ignored.
 */

U032 NVreg_resman_debuglevel = ~0;
MODULE_PARM(NVreg_resman_debuglevel, "i");

